//+------------------------------------------------------------------+
//|                                                   HedgePairs.mq4 |
//|                                            Copyright  2006, JTA |
//|                                        xxxxxxxxxxxxxxxxxxxxxxxxx |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, JTA."

//---- input parameters
extern string    Independent = "EURUSD";
extern int       NumberOfData = 24;

double Lots = 0.1;
int    MagicNumber = 250754;
int    slippage = 3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   if (NumberOfData < 2) NumberOfData = 2;
   if (NumberOfData > 200) NumberOfData = 200;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i;
   double xvar[201], yvar[201];
   double rsx, rsy, rsxy, rsxx, rsyy, c0, cx, corr, gld, gldest, indp;
   string cmtstr;
   
   rsx = 0;rsy = 0;rsxy = 0;rsxx = 0;rsyy = 0;
   for (i = 1 ; i <= NumberOfData ; i++)
   {
      xvar[i] = iClose(Independent, 0, i);
      yvar[i] = iClose(NULL, 0, i);
      rsx = rsx + xvar[i];
      rsy = rsy + yvar[i];
      rsxy = rsxy + xvar[i] * yvar[i];
      rsxx = rsxx + xvar[i] * xvar[i];
      rsyy = rsyy + yvar[i] * yvar[i];
   }
   cx = (NumberOfData * rsxy - rsx * rsy) / (NumberOfData * rsxx - rsx * rsx);
   c0 = (rsy - cx * rsx) / NumberOfData;
   corr = (NumberOfData * rsxy - rsx * rsy);
   corr = corr / MathSqrt(NumberOfData * rsxx - rsx * rsx) / MathSqrt(NumberOfData * rsyy - rsy * rsy);

   indp = iClose(Independent, 0, 0);
   gld = iClose(NULL, 0, 0);
   gldest = c0 + cx * indp;
   int digits = MarketInfo(Independent, MODE_DIGITS);
   
   cmtstr = "\nslope: " + DoubleToStr(cx, Digits) + " const: " + DoubleToStr(c0, Digits) + " Correlation: " + DoubleToStr(corr, 3);
   cmtstr = cmtstr + "\nvalue: " + DoubleToStr(gld, Digits) + " independent: " + DoubleToStr(indp, digits) + " estimation: " + DoubleToStr(gldest, Digits);
   cmtstr = cmtstr + " difference: " + DoubleToStr(gldest-gld, Digits);
   
   Comment(cmtstr);
   return(0);
  }
//+------------------------------------------------------------------+